//<c>   Copyright 1988-1998 by Gerry J. Danen; all rights reserved.

//<t>   ASCII Table Generator

#include"gd_tools.h"
#include"gd_ansi.h"


#define pgVERS_ "V2.01"
#define pgTITL_ "ASCII Table Generator"
#define pgCOPR_ "1988"


#define NAMES 32                        // names of characters less than 0x20
static  UCHAR *ch_names[NAMES] =
{
    "NUL", "SOH", "STX", "ETX", "EOT", "ENQ", "ACK", "BEL", "BS",  "HT",
    "LF",  "VT",  "FF",  "CR",  "SO",  "SI",  "DLE", "DC1", "DC2", "DC3",
    "DC4", "NAK", "SYN", "ETB", "CAN", "EM",  "SUB", "ESC", "FS",  "GS",
    "RS",  "US"
};


void    char_name( int n, char *cname ) // get a name for the character (if any)
{
    strcpy(cname,((n<0) || (n>=NAMES)) ? " " : ch_names[n]);
}


void    main( int argc, char *argv[] )
{
    register int i, j, k;
    char name[4];

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    ansi_cls( 3, stderr );
    logon(1);

    printf( "\n ͻ" );
    printf( "\n  Sig Chr Dec Hex Oct  Chr Dec Hex Oct  Chr Dec Hex Oct " );

    for ( i=0; i < 43; i++ )
    {
        if (argc==1)
            tm_sleep_msecs( 5 );                // delay
        j = i + 43;
        k = j + 43;
        if ( i % 5 == 0 )
            printf( "\n ͹" );

        char_name( i, name );
        if ( i < 32 )
            printf("\n  %3s  ^%c  %02d  %02X %03o ", name, (64 + i), i, i, i);
        else
            printf("\n  %3s   %c  %02d  %02X %03o ", name, i, i, i, i);
        printf("   %c  %02d  %02X %03o ", j, j, j, j);
        if ( k < 127 )
            printf("   %c %3d  %02X %03o ", k, k, k, k);
        else
        {
            if ( k == 127 )
                printf(" DEL %3d  %02X %03o ", k, k, k);
            else
                printf("                 " );
        }
    }
    printf( "\n ͼ" );
    exit( 0 );
}
